/*
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.comma.project.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.xtext.EcoreUtil2;
import org.eclipse.xtext.documentation.IEObjectDocumentationProvider;
import org.obeonetwork.m2doc.element.MImage;
import org.obeonetwork.m2doc.element.impl.MImageImpl;

import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Injector;

import org.eclipse.comma.actions.actions.Action;
import org.eclipse.comma.actions.actions.AssignmentAction;
import org.eclipse.comma.actions.actions.CommandReply;
import org.eclipse.comma.actions.actions.EventCall;
import org.eclipse.comma.actions.generator.plantuml.ActionsUmlGenerator;
import org.eclipse.comma.behavior.behavior.Clause;
import org.eclipse.comma.behavior.behavior.StateMachine;
import org.eclipse.comma.behavior.behavior.Transition;
import org.eclipse.comma.behavior.behavior.TriggeredTransition;
import org.eclipse.comma.behavior.interfaces.interfaceDefinition.Interface;
import org.eclipse.comma.expressions.expression.Expression;
import org.eclipse.comma.expressions.expression.ExpressionConstantBool;
import org.eclipse.comma.expressions.expression.ExpressionConstantInt;
import org.eclipse.comma.expressions.expression.ExpressionConstantReal;
import org.eclipse.comma.expressions.expression.ExpressionConstantString;
import org.eclipse.comma.expressions.expression.ExpressionEnumLiteral;
import org.eclipse.comma.expressions.generator.plantuml.ExpressionsUmlGenerator;
import org.eclipse.comma.project.project.ProjectDescription;
import org.eclipse.comma.signature.comments.InterfaceEventComment;
import org.eclipse.comma.signature.interfaceSignature.Command;
import org.eclipse.comma.signature.interfaceSignature.InterfaceEvent;
import org.eclipse.comma.signature.interfaceSignature.Signature;
import org.eclipse.comma.types.comments.SLCommentLocator;
import org.eclipse.comma.types.types.Dimension;
import org.eclipse.comma.types.types.EnumTypeDecl;
import org.eclipse.comma.types.types.MapTypeConstructor;
import org.eclipse.comma.types.types.MapTypeDecl;
import org.eclipse.comma.types.types.RecordTypeDecl;
import org.eclipse.comma.types.types.SimpleTypeDecl;
import org.eclipse.comma.types.types.Type;
import org.eclipse.comma.types.types.TypeDecl;
import org.eclipse.comma.types.types.TypeReference;
import org.eclipse.comma.types.types.VectorTypeConstructor;
import org.eclipse.comma.types.types.VectorTypeDecl;
import org.eclipse.comma.types.utilities.CommaUtilities;
import org.eclipse.comma.types.utilities.TypeUtilities;

public class DocService {

	private static final String VERSION_TEXT = "This document is generated by CommaSuite version " + CommaUtilities.commaVersion() + ".";

	public String getComMAVersionText(ProjectDescription pd) {
		return VERSION_TEXT;
	}

	public List<SimpleTypeDecl> getSimpleTypes(Signature i) {
		return getSimpleTypes(i.getTypes());
	}

	public List<SimpleTypeDecl> getSimpleTypes(ProjectDescription pd, List<TypeDecl> types) {
		return getSimpleTypes(types);
	}

	public List<SimpleTypeDecl> getSimpleTypes(List<TypeDecl> types) {
		List<SimpleTypeDecl> result = new ArrayList<>();

		for (TypeDecl t : types) {
			if (t instanceof SimpleTypeDecl) {
				result.add((SimpleTypeDecl) t);
			}
		}

		return result;
	}

	public List<EnumTypeDecl> getEnums(Signature i) {
		return getEnums(i.getTypes());
	}

	public List<EnumTypeDecl> getEnums(ProjectDescription p, List<TypeDecl> types) {
		return getEnums(types);
	}

	public List<EnumTypeDecl> getEnums(List<TypeDecl> types) {
		List<EnumTypeDecl> result = new ArrayList<>();

		for (TypeDecl t : types) {
			if (t instanceof EnumTypeDecl)
				result.add((EnumTypeDecl) t);
		}

		return result;
	}

	public List<RecordTypeDecl> getRecordTypes(Signature i) {
		return getRecordTypes(i.getTypes());
	}

	public List<RecordTypeDecl> getRecordTypes(ProjectDescription p, List<TypeDecl> types) {
		return getRecordTypes(types);
	}

	public List<RecordTypeDecl> getRecordTypes(List<TypeDecl> types) {
		List<RecordTypeDecl> result = new ArrayList<>();

		for (TypeDecl t : types) {
			if (t instanceof RecordTypeDecl)
				result.add((RecordTypeDecl) t);
		}
		return result;
	}

	public List<VectorTypeDecl> getVectorTypes(Signature i) {
		return getVectorTypes(i.getTypes());
	}

	public List<VectorTypeDecl> getVectorTypes(ProjectDescription p, List<TypeDecl> types) {
		return getVectorTypes(types);
	}

	public List<VectorTypeDecl> getVectorTypes(List<TypeDecl> types) {
		List<VectorTypeDecl> result = new ArrayList<>();

		for (TypeDecl t : types) {
			if (t instanceof VectorTypeDecl)
				result.add((VectorTypeDecl) t);
		}

		return result;
	}

	public boolean isNull(Object o) {
		return (o == null);
	}

	public boolean isTriggeredTransition(Transition t) {
		return (t instanceof TriggeredTransition);
	}

	public String getTypeName(Type t) {
		StringBuilder builder = new StringBuilder();
		if (t instanceof TypeReference) {
			TypeDecl td = ((TypeReference) t).getType();
			if (td instanceof EnumTypeDecl) {
				builder.append("enum ");
			} else if (td instanceof RecordTypeDecl) {
				builder.append("record ");
			} else if (td instanceof VectorTypeDecl) {
				builder.append("vector ");
			} else if (td instanceof SimpleTypeDecl) {
				builder.append("");
			} else if(td instanceof MapTypeDecl) {
				builder.append("map ");
			}

			builder.append(td.getName());
		} else if(t instanceof VectorTypeConstructor) { // vector constructor
			VectorTypeConstructor vtc = (VectorTypeConstructor) t;
			builder.append(vtc.getType().getName());
			for (Dimension d : vtc.getDimensions()) {
				builder.append("[");
				if (d.getSize() != 0) {
					builder.append(d.getSize());
				}
				builder.append("]");
			}
		} else if(t instanceof MapTypeConstructor) {
			MapTypeConstructor mtc = (MapTypeConstructor) t;
			builder.append("map<")
			       .append(mtc.getType().getName())
			       .append(", ")
			       .append(getTypeName(mtc.getValueType()))
			       .append(">");
		}
		return builder.toString();
	}

	public String getStringFromExpression(Expression expr) {
		if (expr == null)
			return "";

		ExpressionsUmlGenerator exprConverter = new ExpressionsUmlGenerator("", null);
		return exprConverter.generateExpression(expr).toString();
	}

	public String getStringFromAssignment(Action act) {
		if (act == null)
			return "";
		return new ActionsUmlGenerator("", null).generateAction(act).toString();
	}

	public String getVariableName(Action act) {
		if (act instanceof AssignmentAction) {
			return ((AssignmentAction) act).getAssignment().getName();
		}
		return "";
	}

	public String getValue(Action act) {
		if (act instanceof AssignmentAction) {
			return new ActionsUmlGenerator("", null).generateExpression(((AssignmentAction) act).getExp()).toString();
		}
		return "";
	}

	public MImage getDiagram(EObject anObject, String projectPath, String artefactName, Interface behavior) {
		String behaviorFileName = behavior.eResource().getURI().trimFileExtension().lastSegment();
		String path = projectPath + behaviorFileName + "_" + artefactName;
		ResourceSet resourceSet = behavior.eResource().getResourceSet();
		if (anObject instanceof StateMachine) {
			path = path + "_complete";
		}
		URI uris = URI.createFileURI(path + ".png");
		return new MImageImpl(resourceSet.getURIConverter(), uris);
	}

	public String getDocumentation(EObject anObject) {
		String documentation = getDocumentationString(anObject);

		// Normalize by removing new lines
		return documentation.replace("\n", " ");
	}

	public String getInlineDocumentation(EObject anObject) {
		return SLCommentLocator.getSLComment(anObject);
	}

	public boolean returnsVoid(Command ev) {
		return TypeUtilities.isVoid(ev.getType());
	}

	public InterfaceEventComment getCommentObject(InterfaceEvent ev) {
		String coms = getDocumentationString(ev);
		return new InterfaceEventComment(ev, coms);
	}

	public String getReturnComment(InterfaceEventComment coms) {
		return coms.getReturnComment();
	}

	public String getEventComment(InterfaceEventComment coms) {
		return coms.getEventComment();
	}

	public String getCommentForParam(InterfaceEventComment coms, String pName) {
		return coms.getCommentForParam(pName);
	}

	// removes new lines and extra spaces
	public String formatText(String s) {
		String result = s.replace("\n", "");
		return result.replaceAll("\\s\\s+", " ");
	}

	private String getDocumentationString(EObject anObject) {
		Injector injector = Guice.createInjector(new AbstractModule() {

			@Override
			protected void configure() {
				// do nothing
			}
		});

		IEObjectDocumentationProvider documentationProvider = injector.getInstance(IEObjectDocumentationProvider.class);
		String documentation = documentationProvider.getDocumentation(anObject);

		if (documentation != null) {
			return documentation;
		}

		return "";
	}

	public String getPossibleActions(Clause c) {
		List<EventCall> eventCalls = EcoreUtil2.getAllContentsOfType(c, EventCall.class);
		List<CommandReply> replies = EcoreUtil2.getAllContentsOfType(c, CommandReply.class);
		if(eventCalls.isEmpty() && replies.isEmpty()) return "-";

		String result = "";
		Map<InterfaceEvent, Object> usedEvents = new HashMap<InterfaceEvent, Object>();
		for(EventCall evcall : eventCalls) {
			usedEvents.put(evcall.getEvent(), evcall);
		}
		for(InterfaceEvent e : usedEvents.keySet()) {
			result += e.getName() + "\n";
		}
		if(! replies.isEmpty()) {
			boolean bareReplyFound = false;
			for(CommandReply r : replies) {
				String replyAsString = getStringFromReply(r);
				if(replyAsString.equals("reply")) {
					result += !bareReplyFound ? "reply" + "\n" : "";
					bareReplyFound = true;
				}
				else {
					result += replyAsString + "\n";
				}
			}
		}

		return result.substring(0, result.length()-1);
	}

	public String getStringFromReply(CommandReply r) {
		if(! r.getParameters().isEmpty()) {
			Expression exp = r.getParameters().get(0);
			if( exp instanceof ExpressionConstantBool ||
				exp instanceof ExpressionConstantInt ||
				exp instanceof ExpressionConstantReal ||
				exp instanceof ExpressionConstantString ||
				exp instanceof ExpressionEnumLiteral) {

				return "reply(" +
						new ExpressionsUmlGenerator("", null).generateExpression(exp).toString() +
						")";
			}
		}
		return "reply";
	}
}
